class Origami::GiftVoucherController < BaseOrigamiController
  def index
    @sale_id = params[:sale_id]
    @cashier_type   = params[:type]
    # limit gift_voucher_amount
    sale_data = Sale.find_by_sale_id(@sale_id)
    total = 0
    @gift_vouchercount = 0
    @shop        = Shop.first 
    @rounding_adj = 0
    @can_gift_voucher = 0
    @member_discount = 0
    @sub_total = 0
    @membership_id = nil
    @receipt_no = nil
    if !sale_data.nil?
      total = sale_data.grand_total
      
      others    = 0
      
      if @shop.is_rounding_adj
           new_total    = Sale.get_rounding_adjustment(sale_data.grand_total)
      else
          new_total    = sale_data.grand_total
      end
      @rounding_adj = new_total-sale_data.grand_total  
      
      sale_data.sale_payments.each do |sale_payment|
          if sale_payment.payment_method == "gift_voucher"
            @gift_vouchercount = @gift_vouchercount + sale_payment.payment_amount
          else
            others = others + sale_payment.payment_amount
          end
      end
      @can_gift_voucher = total - @gift_vouchercount - others

      @member_discount = MembershipSetting.find_by_discount(1)
      @sub_total       = sale_data.total_amount
      @membership_id   = sale_data.customer.membership_id
      #for bank integration
      @receipt_no      = sale_data.receipt_no
    end
  end

  def create
    cash = params[:amount]
    sale_id = params[:sale_id]
    ref_no  = params[:reference_no]
    if(Sale.exists?(sale_id))
      saleObj = Sale.find(sale_id)
      shop_details =  Shop.first 
      
      # rounding adjustment
      # if shop_details.is_rounding_adj
      #   new_total    = Sale.get_rounding_adjustment(saleObj.grand_total)
      #   rounding_adj = new_total-saleObj.grand_total
      #   saleObj.update_attributes(grand_total: new_total,old_grand_total: saleObj.grand_total,rounding_adjustment:rounding_adj)        
      # end

      # saleObj = Sale.find(sale_id)
      sale_payment = SalePayment.new
      @status, @sale = sale_payment.process_payment(saleObj, current_user, cash, "GiftVoucher",ref_no)
    end
  end

  #Shop Name in Navbor
  helper_method :shop_detail
  def shop_detail
    @shop = Shop.first
  end
end
